﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using Syncfusion.DocIO;
using Syncfusion.DocIO.DLS;
using Xamarin.Forms;

namespace SampleWebView
{
    public partial class WordToHtml : SamplePage
    {
        public WordToHtml()
        {
            InitializeComponent();

            if (Device.Idiom != TargetIdiom.Phone && Device.OS == TargetPlatform.WinPhone)
            {
                this.SampleTitle.HorizontalOptions = LayoutOptions.Start;
                this.Description.HorizontalOptions = LayoutOptions.Start;
                this.Content_1.HorizontalOptions = LayoutOptions.Start;
                this.btnGenerate.HorizontalOptions = LayoutOptions.Start;

                this.SampleTitle.VerticalOptions = LayoutOptions.Center;
                this.Description.VerticalOptions = LayoutOptions.Center;
                this.Content_1.VerticalOptions = LayoutOptions.Center;
                this.btnGenerate.VerticalOptions = LayoutOptions.Center;
            }
            else if (Device.Idiom == TargetIdiom.Phone && Device.OS == TargetPlatform.WinPhone)
            {
                this.Description.FontSize = 18.5;
                this.Content_1.FontSize = 18.5;
                this.SampleTitle.VerticalOptions = LayoutOptions.Center;
                this.Description.VerticalOptions = LayoutOptions.Center;
                this.Content_1.VerticalOptions = LayoutOptions.Center;
                this.btnGenerate.VerticalOptions = LayoutOptions.Center;
            }
        }

        void OnButtonClicked(object sender, EventArgs e)
        {
            Assembly assembly = typeof (App).GetTypeInfo().Assembly;
            // Creating a new document.
            WordDocument document = new WordDocument();
            Stream inputStream =
                assembly.GetManifestResourceStream("SampleWebView.Templates.Template.docx");
            //Open the Word document to convert
            document.Open(inputStream, FormatType.Doc);
            //Export the Word document to HTML file
            MemoryStream stream = new MemoryStream();
            HTMLExport htmlExport = new HTMLExport();
            htmlExport.SaveAsXhtml(document, stream);
            document.Close();
            //Set the stream to start position to read the content as string
            stream.Position = 0;
            StreamReader reader = new StreamReader(stream);
            string htmlString = reader.ReadToEnd();

            //Set the HtmlWebViewSource to the html string
            HtmlWebViewSource html = new HtmlWebViewSource();
            html.Html = htmlString;
            //Create the web view control to view the web page
            WebView view = new WebView();
            view.Source = html;
            ContentPage webpage = new ContentPage();
            webpage.Content = view;
            this.ContentView.Navigation.PushAsync(webpage);
        }
    }
}
